Subroutine CTRPER (XVALT, PCLS)
!   Permute array XVALT randomly, but leaving elements close
!   to their initial locations (nearbyness is controled by PCLS).
! _________________________________________________________________
!   The routine takes the 1...size(XVALT) index array as real
!   values, takes a combination of these values and of random
!   values as a perturbation of the index array, and sorts the
!   initial set according to the ranks of these perturbated indices.
!   The relative proportion of initial order and random order
!   is 1-PCLS / PCLS, thus when PCLS = 0, there is no change in
!   the order whereas the new order is fully random when PCLS = 1.
!   Michel Olagnon - May 2000.
! _________________________________________________________________
      Real, Dimension (:), Intent (InOut) :: XVALT
      Real, Intent (In) :: PCLS
! _________________________________________________________________
      Real, Dimension (Size(XVALT)) :: XINDT
      Integer, Dimension (Size(XVALT)) :: JWRKT
      Real :: PWRK
      Interface
         Subroutine MRGRNK (XVALT, IRNGT)
!   MRGRNK = Merge-sort ranking of an array
            Real, Dimension (:), Intent (In) :: XVALT
            Integer, Dimension (:), Intent (Out) :: IRNGT
         End Subroutine MRGRNK
      End Interface
!
      Call Random_number (XINDT(:))
      PWRK = Min (Max (0.0, PCLS), 1.0)
      XINDT = Real(Size(XVALT)) * XINDT
      XINDT = PWRK*XINDT + (1.0-PWRK)*(/ (Real(I), I=1,size(XVALT)) /)
      Call MRGRNK (XINDT, JWRKT)
      XVALT = XVALT (JWRKT)
End Subroutine CTRPER
