Subroutine UNISTA (XVALT, NUNI)
!   UNISTA = (Stable unique) Removes duplicates from an array,
!            leaving unique entries in the order of their first
!            appearance in the initial set.
!  Michel Olagnon - Feb. 2000
! __________________________________________________________
   Real, Dimension (:), Intent (InOut) :: XVALT
   Integer, Intent (Out) :: NUNI
! __________________________________________________________
      Interface
         Subroutine UNIINV (XVALT, IGOEST)
!   UNIINV = Merge-sort inverse ranking of an array
!            Gives for each index the index of that value in an ordered set
!            where duplicate entries would be removed
            Real, Dimension (:), Intent (In) :: XVALT
            Integer, Dimension (:), Intent (Out) :: IGOEST
         End Subroutine UNIINV
      End Interface
      Integer, Dimension (Size(XVALT)) :: IWRKT
      Logical, Dimension (Size(XVALT)) :: IFMPTYT
      Integer :: ICRS
! __________________________________________________________
      Call UNIINV (XVALT, IWRKT)
      IFMPTYT = .True.
      NUNI = 0
      Do ICRS = 1, Size(XVALT)
         If (IFMPTYT(IWRKT(ICRS))) Then
            IFMPTYT(IWRKT(ICRS)) = .False.
            NUNI = NUNI + 1
            XVALT (NUNI) = XVALT (ICRS)
         End If
      End Do
      Return
End Subroutine UNISTA
